﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using GrapeCity.ActiveReports;
using GrapeCity.ActiveReports.SectionReportModel;
using System.Data;
using System.Data.OleDb;

namespace CreatingSectionReports_CSharp
{
    
    public partial class Form1 : Form
    {
        private static OleDbConnection conn;
        private static OleDbDataReader reader;
        SectionReport rpt;
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            rpt = new SectionReport();

            //Adding Page Header/Footer sections
            rpt.Sections.InsertPageHF();
            rpt.Sections[0].BackColor = Color.LightGray;

            //Adding Detail section
            rpt.Sections.Insert(1, new Detail());
            rpt.Sections[1].BackColor = Color.PeachPuff;
            rpt.Sections[1].Height = 1.5f;

            //Adding label to display first column's name
            GrapeCity.ActiveReports.SectionReportModel.Label lblCategoryID = new GrapeCity.ActiveReports.SectionReportModel.Label();
            lblCategoryID.Location = new PointF(0, 0.05F);
            lblCategoryID.Text = "Category ID";
            lblCategoryID.Alignment = GrapeCity.ActiveReports.Document.Section.TextAlignment.Center;
            lblCategoryID.Font = new System.Drawing.Font("Arial", 10, FontStyle.Bold);
            rpt.Sections[0].Controls.Add(lblCategoryID);

            //Adding label to display second column's name
            GrapeCity.ActiveReports.SectionReportModel.Label lblCategoryName = new GrapeCity.ActiveReports.SectionReportModel.Label();
            lblCategoryName.Location = new PointF(1.459f, 0.05f);
            lblCategoryName.Size = new SizeF(1.094f,0.2f);
            lblCategoryName.Text = "Category Name";
            lblCategoryName.Font = new System.Drawing.Font("Arial", 10, FontStyle.Bold);
            rpt.Sections[0].Controls.Add(lblCategoryName);

            //Adding label to display third column's name
            GrapeCity.ActiveReports.SectionReportModel.Label lblDescription = new GrapeCity.ActiveReports.SectionReportModel.Label();
            lblDescription.Location = new PointF(3.114f, 0.05f);
            lblDescription.Text = "Description";
            lblDescription.Font = new System.Drawing.Font("Arial", 10, FontStyle.Bold);
            rpt.Sections[0].Controls.Add(lblDescription);

            //Adding label to display fourth column's name
            GrapeCity.ActiveReports.SectionReportModel.Label lblPicture = new GrapeCity.ActiveReports.SectionReportModel.Label();
            lblPicture.Location = new PointF(5.219f, 0.05f);
            lblPicture.Alignment = GrapeCity.ActiveReports.Document.Section.TextAlignment.Center;
            lblPicture.Text = "Picture";
            lblPicture.Font = new System.Drawing.Font("Arial", 10, FontStyle.Bold);
            rpt.Sections[0].Controls.Add(lblPicture);

            //Adding Textbox to display first column's records
            GrapeCity.ActiveReports.SectionReportModel.TextBox txtCategoryID = new GrapeCity.ActiveReports.SectionReportModel.TextBox();
            txtCategoryID.Location = new PointF(0,0);
            txtCategoryID.Alignment = GrapeCity.ActiveReports.Document.Section.TextAlignment.Center;
            rpt.Sections[1].Controls.Add(txtCategoryID);

            //Adding Textbox to display second column's records
            GrapeCity.ActiveReports.SectionReportModel.TextBox txtCategoryName = new GrapeCity.ActiveReports.SectionReportModel.TextBox();
            txtCategoryName.Location = new PointF(1.459f,0);
            rpt.Sections[1].Controls.Add(txtCategoryName);

            //Adding Textbox to display third column's records
            GrapeCity.ActiveReports.SectionReportModel.TextBox txtDescription = new GrapeCity.ActiveReports.SectionReportModel.TextBox();
            txtDescription.Location = new PointF(3.114f,0);
            rpt.Sections[1].Controls.Add(txtDescription);

            //Adding Picture control to display image
            GrapeCity.ActiveReports.SectionReportModel.Picture picture = new Picture();
            picture.Location = new PointF(5.219f,0);
            rpt.Sections[1].Controls.Add(picture);

            // Setting report's data source
            conn = new OleDbConnection(@"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\Users\stduser\Documents\ComponentOne Samples\ActiveReports Developer 7\Data\NWIND.mdb;Persist Security Info=False");
            System.Data.OleDb.OleDbCommand cmd = new System.Data.OleDb.OleDbCommand("SELECT * FROM Categories", conn);
            conn.Open();
            reader = cmd.ExecuteReader();
            rpt.DataSource = reader;

            // Assigning DataField properties of controls in the detail section
            txtCategoryID.DataField = "CategoryID";
            txtCategoryName.DataField = "CategoryName";
            txtDescription.DataField = "Description";
            picture.DataField = "Picture";   

            rpt.Run();
            this.viewer1.Document = rpt.Document;
            reader.Close();
            conn.Close();

        }
    }
}
